#!/usr/bin/python
import RPi.GPIO as GPIO
import time

tx = "Zwölf Boxkämpfer jagen Victor quer über den großen Sylter Deich"

LCD_RS = 7
LCD_E  = 8
LCD_D4 = 25
LCD_D5 = 24
LCD_D6 = 23
LCD_D7 = 18

GPIO.setmode(GPIO.BCM)
GPIO.setup(LCD_E,  GPIO.OUT)
GPIO.setup(LCD_RS, GPIO.OUT)
GPIO.setup(LCD_D4, GPIO.OUT)
GPIO.setup(LCD_D5, GPIO.OUT)
GPIO.setup(LCD_D6, GPIO.OUT)
GPIO.setup(LCD_D7, GPIO.OUT)

LCD_WIDTH = 16
LCD_LINE_1 = 0x80
LCD_LINE_2 = 0xC0
LCD_CHR = 1
LCD_CMD = 0
E_PULSE = 0.00005
E_DELAY = 0.00005
INIT  = 0.01
pause = 0.5

def lcd_enable():
    time.sleep(E_DELAY)
    GPIO.output(LCD_E, 1)
    time.sleep(E_PULSE)
    GPIO.output(LCD_E, 0)
    time.sleep(E_DELAY)

def lcd_byte(bits, mode):
    GPIO.output(LCD_RS, mode)
    GPIO.output(LCD_D4, bits&0x10==0x10)
    GPIO.output(LCD_D5, bits&0x20==0x20)
    GPIO.output(LCD_D6, bits&0x40==0x40)
    GPIO.output(LCD_D7, bits&0x80==0x80)
    lcd_enable()
    GPIO.output(LCD_D4, bits&0x01==0x01)
    GPIO.output(LCD_D5, bits&0x02==0x02)
    GPIO.output(LCD_D6, bits&0x04==0x04)
    GPIO.output(LCD_D7, bits&0x08==0x08)
    lcd_enable()

def lcd_string(message):
    message = message.ljust(LCD_WIDTH," ")
    for i in range(LCD_WIDTH):
        lcd_byte(ord(message[i]),LCD_CHR)

def lcd_anzeige(z1, z2):
    lcd_byte(LCD_LINE_1, LCD_CMD)
    lcd_string(z1)
    lcd_byte(LCD_LINE_2, LCD_CMD)
    lcd_string(z2)

LCD_INIT = [0x33, 0x33, 0x32, 0x28, 0x0C, 0x06, 0x01]
for i in LCD_INIT:
    lcd_byte(i,LCD_CMD)
    time.sleep(INIT)

z1 = " " * LCD_WIDTH + tx
z2 = z1.replace("ä", chr(225))
z2 = z2.replace("ö", chr(239))
z2 = z2.replace("ü", chr(245))
z2 = z2.replace("ß", chr(226))
z2 = z2.replace("Ä", chr(225))
z2 = z2.replace("Ö", chr(239))
z2 = z2.replace("Ü", chr(245))

try:
    while True:
        for j in range(len(tx)):
            zeile1 = z1[j:(j + LCD_WIDTH)]
            zeile2 = z2[j:(j + LCD_WIDTH)]
            lcd_anzeige(zeile1, zeile2)
            time.sleep(pause)

except KeyboardInterrupt:
  GPIO.cleanup()
